/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 *\file Show_image.h
 *
 *\date  Created on: 01-mag-2009
 *\author  Author: Claudio Salvadori
 *\brief  Function to render a raw image using FLTK libraries
 */

#ifndef SHOW_IMAGE_H
#define SHOW_IMAGE_H

#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Box.H>
#include <Fl/Fl_Image.H>
#include <stdio.h>

/**	\brief Function to initialize the renderer. This function has to be called
*	 before the function that execute the image rendering \see renderImage
*	\param w		image width 
*	\param h		image height
*/
void initRenderer(unsigned int w, unsigned int h);

/**	\brief Function to rendet the image
* 	\param image 	pointer to the raw image vector
*	\param w		image width 
*	\param h		image height
*	\param channel	number of color channel
*/
void renderImage(unsigned char *image, unsigned int w, unsigned int h, unsigned int channel);

/**	\brief Function to initialize the renderer. This function has to be called
*	 before the function that execute the image rendering \see renderImage
*	\param w		image width 
*	\param h		image height
*/
void initRenderer_black(unsigned int w, unsigned int h);

/**	\brief Function to rendet the a black image
*	\param w		image width 
*	\param h		image height
*	\param x		point x component 
*	\param y		point y component
*/
void renderImage_black(unsigned int w, unsigned int h, unsigned int x, unsigned int y);


void initRendererSX(unsigned int w, unsigned int h);
void renderImageSX(unsigned char *image, unsigned int w, unsigned int h, unsigned int channel);
void initRendererDX(unsigned int w, unsigned int h);
void renderImageDX(unsigned char *image, unsigned int w, unsigned int h, unsigned int channel);
void initRendererDisp(unsigned int w, unsigned int h);
void renderImageDisp(unsigned char *image, unsigned int w, unsigned int h, unsigned int channel);

#endif
